#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>


int main(int argc, char** argv)
{
  int status;
  int pid = fork();

  switch(pid)
    {
    case -1:
      perror("Fork failed");
      exit(-1);
      
    case 0:
      // Child process
      printf("I am the child!\n");
      sleep(10);
      printf("Child done\n");
      break;

    default:
      // Parent process: pid can be any positive integer
      printf("I am the parent of process %d\n", pid);
      sleep(8);
      printf("Waiting for child to terminate\n");
      wait(&status);
      printf("Parent done\n");
      break;
  }

  return(0);
}
